function W = BuildEpsilonGraph(S,eps)
% creates incidence matrix from similarity matrix
% epsilon-neighbourhood method - discards edges with similarity lower than
% a threshold
 
% Input: 
% S = similarity matrix, square, symmetric
% eps = epsilon threshold
 

if (size(S,1) ~= size(S,2))
  error('Matrix S is not square!')
end
n = size(S,1);
  
for it=1:n
  S(it,it) = 0; 
end
 
W = (S >= eps) .* S; 
  
   
  
