function S=CalcSimMatrix(points,sigma)
% generates similarity matrix 
% Euclidean distance and Gaussian kernal

% Input: points = coordinates of points in 2D space (size(num_points,2))
%        sigma = amount of Gaussian noise, variance within cluster

% default parameters
switch(nargin)
  case 0, error('Coordinates of data points are missing.');
  case 1, sigma=0.5;
end

D=DistEuclidean(points,points);
S = exp(- D / (2 * sigma^2));

function D = DistEuclidean(X,Y)
  if( ~isa(X,'double') || ~isa(Y,'double'))
      error( 'Vstupy musi byt typu double.'); end;
  m = size(X,1); n = size(Y,1);  
  Yt = Y';  
  XX = sum(X.*X,2);        
  YY = sum(Yt.*Yt,1);      
  D = XX(:,ones(1,n)) + YY(ones(1,m),:) - 2*X*Yt;
    

        